/*
Copyright (C) 2012 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;

public class Ini {

  private String captureDir = "";
  private String logFilePath = "";
  private String multicastIp = "";
  private int multicastPort = -1;
  private String serverId = "";
  private String unicastIpPortFileForClientPath = "";
  private String execMode = "";
  private int unicastPortForServer = -1;
  private String baseName = "";
  private String userListFilePath = "";
  private String shussekiFilePath = "";
  private String sendImageMode = "";
  private String unicastIpForClient = "";
  private int unicastPortForClient = -1;

  public Ini(String fileName) throws Exception{
    int cnt = 1;
    try{
      FileReader fr = new FileReader(fileName);
      BufferedReader br = new BufferedReader(fr);
      String line;
      while((cnt > 0) && ((line = br.readLine()) != null)){
        switch(cnt++){
        case 1: captureDir = line; break;
        case 2: logFilePath = line; break;
        case 3: multicastIp = line; break;
        case 4: multicastPort = Integer.parseInt(line); break;
        case 5:
          serverId = line;
          for(int i = 0; i < 4 - serverId.length() %4; i++)
            serverId += " ";
          break;
        case 6: unicastIpPortFileForClientPath = line; break;
        case 7:
          execMode = line;
          if(execMode == "")
            cnt = -1;
          break;
        case 8: unicastPortForServer = Integer.parseInt(line); break;
        case 9: baseName = line; break;
        case 10: userListFilePath = line; break;
        case 11: shussekiFilePath = line; break;
        case 12: sendImageMode = line; break;
        default: cnt = -1; break;
        }
      }
      br.close();
      fr.close();
    }catch(Exception e){
      C.throwException("Ini: Ini: cnt=" + cnt + ": ", e);
    }
  }

  public String getCaptureDir(){ return captureDir; }
  public String getLogFilePath(){ return logFilePath; }
  public String getMulticastIp(){ return multicastIp; }
  public int getMulticastPort(){ return multicastPort; }
  public String getServerId(){ return serverId; }
  public String getUnicastIpPortFileForClientPath(){ return unicastIpPortFileForClientPath; }
  public String getExecMode(){ return execMode; }
  public int getUnicastPortForServer(){ return unicastPortForServer; }
  public String getBaseName(){ return baseName; }
  public String getUserListFilePath(){ return userListFilePath; }
  public String getShussekiFilePath(){ return shussekiFilePath; }
  public String getSendImageMode(){ return sendImageMode; }
  public String getUnicastIpForClient(){ return unicastIpForClient; }
  public int getUnicastPortForClient(){ return unicastPortForClient; }

  public void writeUnicastIpPortFileForClient(String ipAddress) throws Exception{
    try{
      FileWriter fw = new FileWriter(unicastIpPortFileForClientPath, false);
      String s = ipAddress + C.cr;
      fw.write(s, 0, s.length());
      s = "" + unicastPortForServer + C.cr;
      fw.write(s, 0, s.length());
      fw.close();
    }catch(Exception e){
      C.throwException("Ini: writeUnicastIpPortFileForClient:", e);
    }
  }

  public void readUnicastIpPortFileForClient() throws Exception{
    try{
      FileReader fr = new FileReader(unicastIpPortFileForClientPath);
      BufferedReader br = new BufferedReader(fr);
      String line;
      int cnt = 1;
      while((cnt > 0) && ((line = br.readLine()) != null)){
        switch(cnt++){
        case 1: unicastIpForClient = line; break;
        case 2: unicastPortForClient = Integer.parseInt(line); break;
        default: cnt = -1; break;
        }
      }
      br.close();
      fr.close();
    }catch(Exception e){
      C.throwException("Ini: readUnicastIpPortFileForClient:", e);
    }
  }

}
