/*
Copyright (C) 2012 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import java.net.MulticastSocket;
import java.net.DatagramPacket;
import java.net.InetAddress;

public class Multicast extends Thread {

  protected final int BUF_SIZE = 1024+256;
  protected byte[] rcvBuf;
  protected byte[] sndBuf;
  private MulticastSocket rcvSocket;
  private DatagramPacket rcvPacket;
  private MulticastSocket sndSocket;
  private DatagramPacket sndPacket;
  private InetAddress addr;
  private int port;

  public Multicast(String _ip, int _port) throws Exception{
    try{
      port = _port;
      rcvBuf = new byte[BUF_SIZE];
      rcvPacket = new DatagramPacket(rcvBuf, rcvBuf.length);
      rcvSocket = new MulticastSocket(port);
      addr = InetAddress.getByName(_ip);
      rcvSocket.joinGroup(addr);
      sndBuf = new byte[BUF_SIZE];
      sndPacket = new DatagramPacket(sndBuf, sndBuf.length, addr, port);
      sndSocket = new MulticastSocket();
      C.d("Multicast: Multicast: sndSocket.getTimeToLive()=" + sndSocket.getTimeToLive());
      start();
    }catch(Exception e){
      C.throwException("Multicast: Multcast:", e);
    }
  }

  public void run(){
    try{
      while(true){
        rcvSocket.receive(rcvPacket);
        receive();
      }
    }catch(Exception e){
      C.log("Multicast: run:" + C.cr + e.toString());
    }
  }

  public void receive(){}

  public void send() throws Exception{
    try{
      sndSocket.send(sndPacket);
    }catch(Exception e){
      C.throwException("Multicast: send:", e);
    }
  }

}
