/*
Copyright (C) 2012 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
public class ServerMulticast extends BaseMulticast {

  public ServerMulticast(Snapshot _snapshot) throws Exception{
    super(_snapshot);
  }

  public void receive(){
    try{
      if(!serverId.equals(getServerId()))
        return;
      switch(getCmd()){
      case CLIENT_SEND_IMAGE:
        receiveImage((BaseCanvas)(snapshot.server.getServerCanvas()));
        break;
      case REQUEST_REPAINT:
        snapshot.server.getServerCanvas().repaint();
        break;
      }
    }catch(Exception e){
      C.e("ServerMulticast: receive: " + e.toString());
    }
  }

}
